# Contributing to Study Group Event Visualization

Thank you for your interest in contributing to **Study Group Event Visualization** :tada:! 
If you're interested in contributing, you should find all of the details here. We've centralized it into this repository, we'd like to keep things tidy and focused. Issues and roadmap goals will reflect changes across multiple repositories on Github, so you'll have the opportunity to contribute to multiple aspects of this project.

**Study Group Event Visualization** is to create a friendly, no-pressure environment where people can share their work, ask for help on a coding problem, and learn and work together with their peers.We'd like to create a useful workflow between these tools and datasets, enabling us to create visualizations of the activities or events from all Study Groups globally. There are multiple steps to this process, with the overall goal of improving web visibility and accessibility for our Study Group community.

This document is a set of guidelines for contributing to **Study Group Event Visualization** on GitHub. These are guidelines, not rules. This guide is meant to make it easy for you to get involved.

* [Participation guidelines](#participation-guidelines)
* [What we're working on](#what-were-working-on)
* [How to submit changes](#how-to-submit-changes)
* [How to report bugs](#how-to-report-bugs)
* [Communication channels](#communication-channels)

## Participation guidelines

This project adheres to a [Mozilla Community Guidelines](https://www.mozilla.org/en-US/about/governance/policies/participation/). By participating, you are expected to uphold this code. Please report unacceptable behavior to [Aurelia](https://gitter.im/auremoser).

## What we're working on

Take a look at the issues in our [current milestone](https://github.com/mozillascience/studyGroupEvents/issues) or browse for some good first bugs to get started! 

## How to submit changes

Once you've identified one of the issues above that you feel you can contribute to, you're ready to make a change to the project repository! 
Try not to pollute your pull request with unintended changes – keep them simple and small. If possible, squash your commits.
 
 1. **[Fork](https://help.github.com/articles/fork-a-repo/) this repository**. This makes your own version of this project you can edit and use.
 2. **[Make your changes](https://guides.github.com/activities/forking/#making-changes)**! You can do this in the GitHub interface on your own local machine. Once you're happy with your changes...
 3. **Submit a [pull request](https://help.github.com/articles/proposing-changes-to-a-project-with-pull-requests/)**. This opens a discussion around your project and lets the project lead know you are proposing changes.

 First time contributing to open source? Check out this *free* series, [How to Contribute to an Open Source Project on GitHub](https://egghead.io/series/how-to-contribute-to-an-open-source-project-on-github).

## How to report bugs

Notice a mistake? Please file any bugs, requests, or questions in our [issue tracker](https://github.com/mozillascience/studyGroupEvents/issues)!

- **Search for existing issues.** Please check to see if someone else has reported the same issue.
- **Share as much information as possible.** Include operating system and version, browser and version. Also, include steps to reproduce the bug.

## Communication channels

If you have anything to share, anything at all, feel free to drop by the Study Group [room](https://gitter.im/mozillascience/studyGroup) on Gitter and say hi. We would love to hear from you. You can also contact [Aurelia](https://gitter.im/auremoser) or [Anamika](https://gitter.im/AnamikaD).
